package de.donmanfred;

import com.samsung.android.sdk.healthdata.HealthConstants;
import com.samsung.android.sdk.healthdata.HealthConstants.StepCount;
import com.samsung.android.sdk.healthdata.HealthDataResolver;
import com.samsung.android.sdk.healthdata.HealthDataResolver.Filter;
import com.samsung.android.sdk.shealth.Shealth;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("Filter")
//@Events(values={"onConnected()","onDisConnected()","onConnectionFailed(error As String)"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 * com.google.firebase:firebase-database
 */

public class FilterWrapper extends AbsObjectWrapper<Filter> {
	private BA ba;

	public FilterWrapper initialize(final BA ba, long startTime, long endTime) {
		this.ba = ba;
		HealthDataResolver.Filter filter = Filter.and(Filter.greaterThanEquals(StepCount.START_TIME, startTime),Filter.lessThanEquals(StepCount.END_TIME, endTime));
		setObject(filter);
		return this;
	}
	@SuppressWarnings("static-access")
	public FilterWrapper and(Filter filter, Filter additionalFilters) {
		getObject().and(additionalFilters, additionalFilters);
		return this;
	}
	@SuppressWarnings({ "static-access", "unchecked" })
	public FilterWrapper greaterThan(String property, Comparable value) {
		getObject().greaterThan(property, value);
		return this;
	}
	@SuppressWarnings({ "static-access", "unchecked" })
	public FilterWrapper greaterThanEquals(String property, Comparable value) {
		//String str = HealthConstants.StepCount.START_TIME;
		getObject().greaterThanEquals(property, value);
		return this;
	}
	@SuppressWarnings({ "static-access", "unchecked" })
	public FilterWrapper lessThan(final BA ba, String property, Comparable value) {
		getObject().lessThan(property, value);
		return this;
	}
	@SuppressWarnings({ "static-access", "unchecked" })
	public FilterWrapper lessThanEquals(final BA ba, String property, Comparable value) {
		getObject().lessThanEquals(property, value);
		return this;
	}
	@SuppressWarnings({ "static-access", "unchecked" })
	public FilterWrapper not(final BA ba, Filter filter) {
		getObject().not(filter);
		return this;
	}
	@SuppressWarnings({ "static-access", "unchecked" })
	public FilterWrapper or(final BA ba, Filter filter) {
		getObject().or(filter);
		return this;
	}
		
}
