package de.donmanfred;

import com.samsung.android.sdk.healthdata.HealthConnectionErrorResult;
import com.samsung.android.sdk.healthdata.HealthDataStore;
import com.samsung.android.sdk.healthdata.HealthDataStore.ConnectionListener;
import com.samsung.android.sdk.healthdata.IHealth;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ShortName;

@ShortName("HealthDataStore")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
@Events(values={"onConnected()","onDisConnected()","onConnectionFailed(errorCode As int, hasResolution As Boolean,error As String)"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 * com.google.firebase:firebase-database
 */

public class HealthDataStoreWrapper extends AbsObjectWrapper<HealthDataStore> {
	private BA ba;
	private String eventName;

	public void Initialize(final BA ba, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;

		final HealthDataStore _obj = new HealthDataStore(ba.context, new ConnectionListener(){

			@Override
			public void onConnected() {
				// TODO Auto-generated method stub
				//ba.Log("lib:todo:onconnected");
	 			if (ba.subExists(eventName + "_onconnected")) {
  				BA.Log("lib:Raising.. "+eventName + "_onconnected()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onconnected", true, new Object[] {});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onconnected");
  			}
				
			}

			@Override
			public void onConnectionFailed(HealthConnectionErrorResult result) {
				// TODO Auto-generated method stub
	 			if (ba.subExists(eventName + "_onconnectionfailed")) {
  				BA.Log("lib:Raising.. "+eventName + "_onconnectionfailed()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onconnectionfailed", true, new Object[] {result.getErrorCode(),result.hasResolution(),result.toString()});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onconnectionfailed");
  			}
				
			}

			@Override
			public void onDisconnected() {
				// TODO Auto-generated method stub
	 			if (ba.subExists(eventName + "_ondisconnected")) {
  				BA.Log("lib:Raising.. "+eventName + "_ondisconnected()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_ondisconnected", true, new Object[] {});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_ondisconnected");
  			}
				
			}});
		final String eventName = EventName.toLowerCase(BA.cul);
		setObject(_obj);
	}

	public void ConnectService(){
		getObject().connectService();
	}
	
	public String getSocketKey(){
		return getObject().getSocketKey();
	}
	public String getPlatformPackageName(){
		return getObject().getPlatformPackageName();
	}
	public long getMyUserId(){
		return getObject().getMyUserId();
	}
	public IHealth getInterface(HealthDataStore store){
		IHealth ih = getObject().getInterface(store);
		
		return getObject().getInterface(store);
	}

	public void DisConnectService(){
		getObject().disconnectService();
	}

	public void ConnectService2(long timeout){
		getObject().connectService(timeout);
	}
		
}
