package de.donmanfred;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.samsung.android.sdk.healthdata.HealthConstants;
import com.samsung.android.sdk.healthdata.HealthDataStore;
import com.samsung.android.sdk.healthdata.HealthPermissionManager;
import com.samsung.android.sdk.healthdata.HealthPermissionManager.PermissionKey;
import com.samsung.android.sdk.healthdata.HealthPermissionManager.PermissionResult;
import com.samsung.android.sdk.healthdata.HealthPermissionManager.PermissionType;
import com.samsung.android.sdk.healthdata.HealthResultHolder;
import com.samsung.android.sdk.healthdata.HealthResultHolder.ResultListener;
import com.samsung.android.sdk.shealth.Shealth;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Events;
import anywheresoftware.b4a.BA.ShortName;

@ShortName("HealthPermissionManager")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
@Events(values={"onPermissionResult(Count As int, Result As Boolean,status As int)"})
//@DependsOn(values={"samsung-digital-health-healthdata-1.2.1"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 * com.google.firebase:firebase-database
 */

public class HealthPermissionManagerWrapper extends AbsObjectWrapper<HealthPermissionManager> {
	private BA ba;
	private String eventName;
	private HashSet<PermissionKey> mKeySet;

	public HealthPermissionManagerWrapper Initialize(final BA ba, String EventName, HealthDataStore ds) {
		this.ba = ba;
		this.eventName = EventName.toLowerCase(BA.cul);

		final HealthPermissionManager _obj = new HealthPermissionManager(ds);
		setObject(_obj);
		final String eventName = EventName.toLowerCase(BA.cul);
		return this;
	}
	public  void requestPermissions(Set<PermissionKey> permissionKeys){
		HealthResultHolder<PermissionResult> holder = getObject().requestPermissions(permissionKeys,ba.activity);
		holder.setResultListener(new ResultListener<PermissionResult>(){

			@Override
			public void onResult(PermissionResult result) {
				// TODO Auto-generated method stub
	 			if (ba.subExists(eventName + "_onpermissionresult")) {
  				BA.Log("lib:Raising.. "+eventName + "_onpermissionresult()");								
  				//app.raiseEvent(app.context, eventName+"_pagerendered", i, pageCount, filename+"-" + i + ".png");
  				Map<PermissionKey, Boolean> resmap = result.getResultMap();
  				ba.raiseEventFromDifferentThread(this, null, 0, eventName + "_onpermissionresult", true, new Object[] {result.getCount(),resmap.containsValue(Boolean.FALSE),result.getStatus()});
  			}else {
  				BA.Log("lib: NOTFOUND '"+eventName + "_onpermissionresult");
  			}

			}});
				
	}
	public void checkandrequestPermissionAcquired(Set<PermissionKey> permissionKeys){
		Map<PermissionKey, Boolean> result = getObject().isPermissionAcquired(permissionKeys);
		if (result.containsValue(Boolean.FALSE)) {
			requestPermissions(permissionKeys);
		}
	}
	public boolean getPermissionGranted(Set<PermissionKey> permissionKeys){
		Map<PermissionKey, Boolean> result = getObject().isPermissionAcquired(permissionKeys);
		if (result.containsValue(Boolean.FALSE)) {
			return false;
		} else {
			return true;
		}
	}
		
	public HashSet<PermissionKey> getStepCountPermission(){
		mKeySet = new HashSet<PermissionKey>();
    mKeySet.add(new PermissionKey(HealthConstants.StepCount.HEALTH_DATA_TYPE, PermissionType.READ));
    return mKeySet;
	}
}
