package de.donmanfred;

import java.util.List;

import com.samsung.android.sdk.healthdata.HealthDataResolver.Filter;
import com.samsung.android.sdk.healthdata.HealthDataResolver.ReadRequest;
import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ShortName;

@ShortName("ReadRequestBuilder")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onConnected()","onDisConnected()","onConnectionFailed(error As String)"})
//@DependsOn(values={"samsung-digital-health-healthdata-1.2.1"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 * com.google.firebase:firebase-database
 */

public class ReadRequestBuilderWrapper extends AbsObjectWrapper<ReadRequest.Builder> {
	private BA ba;

	public ReadRequestBuilderWrapper Initialize(final BA ba) {
		this.ba = ba;

		final ReadRequest.Builder _obj = new ReadRequest.Builder();
		setObject(_obj);
		return this;
	}
	public ReadRequest build(){
		return getObject().build();
	}
	public ReadRequestBuilderWrapper setTimeBefore(long time){
		getObject().setTimeBefore(time);
		return this;
	}
	public ReadRequestBuilderWrapper setTimeAfter(long time){
		getObject().setTimeAfter(time);
		return this;
	}
public ReadRequestBuilderWrapper setSourceDevices(List<String> uuidList){
		getObject().setSourceDevices(uuidList);
		return this;
	}
	public ReadRequestBuilderWrapper setResultCount(int offset, int count){
		getObject().setResultCount(offset, count);
		return this;
	}
	public ReadRequestBuilderWrapper setPropertyAlias(String property, String alias){
		getObject().setPropertyAlias(property, alias);
		return this;
	}
	public ReadRequestBuilderWrapper setProperties(String[] properties){
		getObject().setProperties(properties);
		return this;
	}
	public ReadRequestBuilderWrapper setPackageName(String packageName){
		getObject().setPackageName(packageName);
		return this;
	}
	public ReadRequestBuilderWrapper setFilter(Filter filter){
		getObject().setFilter(filter);
		return this;
	}
	public ReadRequestBuilderWrapper setDataType(String type){
		getObject().setDataType(type);
		return this;
	}
		
}
