package de.donmanfred;

import java.util.List;

import com.samsung.android.sdk.healthdata.HealthData;
import com.samsung.android.sdk.healthdata.HealthDataResolver.Filter;
import com.samsung.android.sdk.healthdata.HealthDataResolver.ReadRequest;
import com.samsung.android.sdk.healthdata.HealthDataResolver.UpdateRequest;

import anywheresoftware.b4a.AbsObjectWrapper;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.ShortName;

@ShortName("UpdateRequestBuilder")
//@Permissions(values={"android.permission.INTERNET", "android.permission.ACCESS_NETWORK_STATE"})
//@Events(values={"onConnected()","onDisConnected()","onConnectionFailed(error As String)"})
//@DependsOn(values={"samsung-digital-health-healthdata-1.2.1"})

/**
 * com.android.support:support-v4
 * com.android.support:appcompat-v7
 * com.android.support:cardview-v7
 * com.android.support:gridlayout-v7
 * com.android.support:mediarouter-v7
 * com.android.support:palette-v7
 * com.android.support:recyclerview-v
 * com.android.support:preference-v7
 * com.android.support:support-v13
 * com.google.firebase:firebase-database
 */

public class UpdateRequestBuilderWrapper extends AbsObjectWrapper<UpdateRequest.Builder> {
	private BA ba;

	public UpdateRequestBuilderWrapper Initialize(final BA ba) {
		this.ba = ba;

		final UpdateRequest.Builder _obj = new UpdateRequest.Builder();
		setObject(_obj);
		return this;
	}
	public UpdateRequest build(){
		return getObject().build();
	}
	public UpdateRequestBuilderWrapper setHealthData(HealthData data){
		getObject().setHealthData(data);
		return this;
	}
	public UpdateRequestBuilderWrapper setSourceDevices(List<String> uuidList){
		getObject().setSourceDevices(uuidList);
		return this;
	}
	public UpdateRequestBuilderWrapper setFilter(Filter filter){
		getObject().setFilter(filter);
		return this;
	}
	public UpdateRequestBuilderWrapper setDataType(String type){
		getObject().setDataType(type);
		return this;
	}
		
}
